package net.minecraftforge.client.model.pipeline;

import net.minecraft.client.renderer.VertexBuffer;
import net.minecraft.client.renderer.vertex.VertexFormat;
import net.minecraft.client.renderer.vertex.VertexFormatElement.EnumUsage;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.EnumFacing;

/**
 * Assumes VertexFormatElement is present in the VertexBuffer's vertex format.
 */
public class VertexBufferConsumer implements IVertexConsumer
{
    private static final float[] dummyColor = new float[]{ 1, 1, 1, 1 };
    private final VertexBuffer renderer;
    private final int[] quadData;
    private int v = 0;
    private BlockPos offset = BlockPos.field_177992_a;

    public VertexBufferConsumer(VertexBuffer renderer)
    {
        super();
        this.renderer = renderer;
        quadData = new int[renderer.func_178973_g().func_177338_f()/* / 4 * 4 */];
    }

    public VertexFormat getVertexFormat()
    {
        return renderer.func_178973_g();
    }

    public void put(int e, float... data)
    {
        VertexFormat format = getVertexFormat();
        if(renderer.isColorDisabled() && format.func_177348_c(e).func_177375_c() == EnumUsage.COLOR)
        {
            data = dummyColor;
        }
        LightUtil.pack(data, quadData, format, v, e);
        if(e == format.func_177345_h() - 1)
        {
            v++;
            if(v == 4)
            {
                renderer.func_178981_a(quadData);
                renderer.func_178987_a(offset.func_177958_n(), offset.func_177956_o(), offset.func_177952_p());
                //Arrays.fill(quadData, 0);
                v = 0;
            }
        }
    }

    public void setOffset(BlockPos offset)
    {
        this.offset = new BlockPos(offset);
    }

    public void setQuadTint(int tint) {}
    public void setQuadOrientation(EnumFacing orientation) {}
    public void setApplyDiffuseLighting(boolean diffuse) {}
}
